Whamcloud - gitweb
LU-5094 Fetch SLES11SP3 build artifacts automatically
[fs/lustre-release.git] / contrib / lbuild / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
22
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
26
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
29
30 # increment this if you have made a change that should force a new kernel
31 # to build built
32 #BUILD_GEN=1
33 #BUILD_GEN=2    # bz19952: remove -lustre tag from kernel RPM names
34 #BUILD_GEN=3    # bz19975: enable the building of src.rpms by default
35 #BUILD_GEN=4    # bz22281: use the git hash in the kernel extra version
36 #BUILD_GEN=5    # TT-107: don't cache the BUILD dir
37 BUILD_GEN=6     # TT-1092: don't cache the BUILD dir, to rebuild external OFED
38
39 TOPDIR=$PWD
40
41 KERNELDIR=
42 LINUX=
43 LUSTRE=
44 RELEASE=false
45 # XXX - some recent hacking has pretty much neutered this option.
46 #       search through this file for "-bb" and see how many places
47 #       simply don't account for this option
48 DO_SRC=true
49 DOWNLOAD=true
50 CANONICAL_TARGET=
51 TARGET=
52 TARGET_ARCH="$(uname -m)"
53 # change default behavior to only build for the current arch
54 TARGET_ARCHS="$TARGET_ARCH"
55 TARGET_ARCHS_ALL="$TARGET_ARCH"
56 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
57 CONFIGURE_FLAGS=
58 EXTERNAL_PATCHES=
59 EXTRA_VERSION=
60 STAGEDIR=
61 TMPDIR=${TMPDIR:-"/var/tmp"}
62 TIMESTAMP=
63 # this is a dir to try reuse old kernel RPMs in (although, it seems to be
64 # unused in any real manner
65 REUSERPM=
66 # this is the dir that should be used to store reuse products
67 REUSEBUILD=
68 # should cached products be used or force rebuilding?
69 USE_BUILD_CACHE=true
70 # what does this do exactly?  does it imply no kernel build?
71 NORPM=false
72 IOKITRPM=true
73 OSDLDISKFSRPM=true
74 OSDZFSRPM=false
75 SMPTYPES="smp bigsmp default ''"
76 PATCHLESS=false
77 XEN=false
78 LINUXOBJ=
79 DISTRO=
80 KERNELTREE=
81 # default to not adding -lustre- into the kernel RPM package names
82 KERNEL_LUSTRE_NAMING=false
83 # default not use kabi check.
84 USE_KABI=false
85
86 # patchless build
87 KERNELRPMSBASE=
88 RPMSMPTYPE=
89
90 # from target file
91 SERIES=
92 BASE_ARCHS=
93 BIGMEM_ARCHS=
94 BOOT_ARCHS=
95 JENSEN_ARCHS=
96 SMP_ARCHS=
97 BIGSMP_ARCHS=
98 PSERIES64_ARCHS=
99 UP_ARCHS=
100
101 # not in the target file any more
102 CONFIG=
103
104 # build the lustre-tests rpm?
105 LUSTRE_TESTS=true
106
107 DATE=$(date)
108
109 RPMBUILD=
110
111 export CC=${CC:-gcc}
112
113 # Readlink is not present on some older distributions: emulate it.
114 readlink() {
115     local path=$1 ll
116
117     if [ -L "$path" ]; then
118         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
119         echo "${ll/* -> }"
120     else
121         return 1
122     fi
123 }
124
125 usage() {
126     cat <<EOF
127 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
128
129   --external-patches=EXTERNAL_PATCHES
130     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
131     look for seres and config files in before looking in the lustre
132     tree.
133
134   --extraversion=EXTRAVERSION
135     Text to use for the rpm release and kernel extraversion.
136
137   --timestamp=TIMESTAMP
138     Date of building lustre in format YYYYMMDDhhmmss
139
140   --reuserpm=DIR
141     Try to reuse old kernel RPMs from DIR
142
143   --reusebuild=DIR
144     Try to reuse old kernel builds from DIR
145
146   --kernelrpm=DIR
147     Path to distro kernel RPM collection
148
149   --ccache
150     Use ccache
151
152   --norpm
153     Do not build RPMs (compile only mode)
154
155   --patchless
156     Build lustre client only
157
158   --distro=DISTRO
159     Which distro using. Autodetect by default
160
161   --kerneldir=KERNELDIR
162     Directory containing Linux source tarballs referenced by target
163     files.
164
165   --kerneltree=KERNELTREE
166     Directory containing dirs with Linux source tarballs referenced by target
167     files. Dir names in format kernel version ('2.6.9', etc.)
168
169   --linux=LINUX --with-linux=LINUX
170     Directory of Linux kernel sources.  When this option is used, only
171     Lustre modules and userspace are built.
172
173   --lustre=LUSTRE
174     Path to an existing lustre source tarball to use.
175
176   --nodownload
177     Do not try to download a kernel from downloads.lustre.org
178
179   --nosrc
180     Do not build a .src.rpm, a full kernel patch, or a patched kernel
181     tarball.
182
183   --ldiskfs
184     Build with ldiskfs support. (Deprecated, always true)
185
186   --noiokit
187     Do not build lustre-iokit RPM. Now true by default
188
189   --publish
190     Unused.
191
192   --release
193     Specifies that the files generated do not include timestamps, and
194     that this is an official release.
195
196   --src
197     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
198
199   --stage=DIR
200     Directory used to stage packages for release.  RPMs will be placed
201     more or less in DIR/<target>-<arch>, and the tarball will be
202     placed in DIR.
203
204   --target=TARGET
205     The name of the target to build.  The available targets are listed
206     below.
207
208   --target-archs=TARGET_ARCHS
209     A (space delimited) list of architectures to build.  By default,
210     all of the archs supported by the TARGET will be built, in
211     addition to a .src.rpm.  This option can limit those, for machines
212     that can only build certain archs or if you only want a certain
213     arch built (for testing, or a one-off kernel).
214
215     Also note that by using a non-"base" arch (eg, i386) only kernels
216     will be built - there will be no lustre-lite-utils package.
217
218   --xen
219     Builds a Xen domX kernel.
220
221   --set-value
222     Sets a variable to a given value.
223
224 EOF
225
226 #   list_targets
227
228     fatal "$1" "$2"
229 }
230
231 # canonicalize a relative path to a file
232 canon_filepath() {
233     local PATH="$1"
234
235     if [ ! -f "$PATH" ]; then
236         return 1
237     fi
238
239     local FILE=${PATH##*/}
240     local DIR=${PATH%/*}
241
242     echo $(canon_path "$DIR")/$FILE
243     return 0
244 }
245
246 # canonicalize a relative path to a dir
247 canon_path() {
248     local PATH="$1"
249
250     if [ ! -d "$PATH" ]; then
251         return 1
252     fi
253
254     pushd "$PATH" >/dev/null || return 1
255     local CANONPATH=$PWD
256     popd >/dev/null
257
258     echo "$CANONPATH"
259     return 0
260 }
261
262 check_options() {
263
264     if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
265         usage 1 "Could not find Lustre source tarball '$LUSTRE'."
266     fi
267
268     if [ -z "$DISTRO" ] ; then
269         DISTRO=$(autodetect_distro)
270         # remove minor version only for rhel and oel
271         [[ $DISTRO =~ "el-" ]] && DISTRO=${DISTRO%%.*}
272         # remove separator
273         DISTRO=${DISTRO/-/}
274     fi
275
276     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
277
278     if [ -z "$LINUX" ]; then
279         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
280             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
281
282         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
283             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
284
285 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
286 #       [ -r "$TARGET_FILE" ] || \
287 #               usage 1 "Target '$TARGET' was not found."
288     fi
289
290     case $TARGET in
291         2.6-rhel6)
292             CANONICAL_TARGET="rhel6"
293             ;;
294         2.6-rhel5)
295             CANONICAL_TARGET="rhel5"
296             ;;
297         2.6-rhel4)
298             CANONICAL_TARGET="rhel-2.6"
299             ;;
300         2.6-suse)
301             CANONICAL_TARGET="sles-2.6"
302             ;;
303         2.6-sles10)
304             CANONICAL_TARGET="sles10-2.6"
305             ;;
306         2.6-sles11 | 3.0-sles11)
307             CANONICAL_TARGET="sles11"
308             ;;
309         2.6-oel5)
310             CANONICAL_TARGET="oel5"
311             ;;
312         hp_pnnl-2.4)
313             CANONICAL_TARGET="hp-pnnl-2.4"
314             ;;
315         2.6-vanilla \
316             | suse-2.4.21-2 \
317             | rh-2.4 \
318             | rhel-2.4 \
319             | sles-2.4 \
320             | 2.6-patchless)
321                 CANONICAL_TARGET="$TARGET"
322                 ;;
323     esac
324
325     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
326     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
327     local timestamplength="${#TIMESTAMP}"
328     if [ $timestamplength -eq 12 ]; then
329         TIMESTAMP="${TIMESTAMP}00"
330     elif [ $timestamplength -ne 14 ]; then
331         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
332     fi
333
334     RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
335     if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
336         RPMBUILD=$(which rpm 2>/dev/null | head -1)
337         if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
338             usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
339         fi
340     fi
341
342     if [ -n "$CCACHE" ]; then
343         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
344
345         if which "$CCACHE" &>/dev/null; then
346             local ccache=$(which "$CCACHE")
347             local bindir="$TOPDIR/bin"
348
349             if [ ! -d $bindir ]; then
350                 mkdir -p $bindir || fatal 1 "error trying to create $bindir"
351             else
352                 rm ${bindir}/* > /dev/null 2>&1 || true
353             fi
354             ln -s "$ccache" ${bindir}/ccache
355             ln -s "$ccache" ${bindir}/cc
356             ln -s "$ccache" ${bindir}/$CC
357             export PATH=$bindir:$PATH
358             export CCACHE && export CC="ccache $CC"
359             # zero the cache so we can see how effective we are being with it
360             echo -n "ccache "
361             ccache -z
362
363             # get some ccache stats when we are done
364             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
365             # should remove the ccache trap if lbuild is interrupted
366             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
367         fi
368     fi
369
370     return 0
371
372 }
373
374 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
375 compare_version () {
376     [[ $1 == $2 ]] && return 1
377     local IFS=.
378     local i val1=($1) val2=($2)
379
380     # padding zero to val1 if it needs
381     for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
382         val1[i]=0
383     done
384     for ((i=0; i<${#val1[@]}; i++)); do
385         [[ -z ${val2[i]} ]] && return 1
386
387         if [[ ${val1[i]} < ${val2[i]} ]]; then
388             return 0
389         elif [[ ${val1[i]} > ${val2[i]} ]]; then
390             return 1
391         fi
392     done
393 }
394
395 uniqify() {
396
397     echo $(echo "$*" | xargs -n 1 | sort -u)
398
399 }
400
401 fetch_url() {
402     local url="$1"
403     local target="$2"
404
405     if [ -z "$target" ]; then
406         fatal 1 "fetch_url() called without a target to fetch to"
407     fi
408
409     if [ -d $target ]; then
410         target+="/${url##*/}"
411     fi
412
413     local rc=0
414     if which wget >/dev/null 2>&1; then
415         if ! wget -nv "$url" -O "$target"; then
416             rc=${PIPESTATUS[0]}
417         fi
418     elif which curl >/dev/null 2>&1; then
419         if ! curl -n -L -s -o "$target" "$url"; then
420             rc=${PIPESTATUS[0]}
421         fi
422     else
423         fatal 1 "Could not find either wget or curl to fetch URLs."
424     fi
425
426     return $rc
427
428 }
429
430 download_srpm() {
431     local target=$1
432     local srpm=$2
433     local force="${3:-false}"
434
435     if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
436        [ ! -s "$KERNELDIR/$srpm" ]; then
437         if $DOWNLOAD; then
438             local location="http://downloads.lustre.org/public/kernels/$target/old"
439             # get the location from a distro specific method if it exists
440             if type -p kernel_srpm_location; then
441                 location=$(kernel_srpm_location)
442             fi
443             echo "Downloading $location/$srpm..."
444             if ! fetch_url "$location/$srpm" "$KERNELDIR/$srpm" 2>&1 ||
445                [ ! -s "$KERNELDIR/$srpm" ]; then
446                 rm -f $KERNELDIR/$srpm
447                 # punt to a distro specific method if it exists
448                 if ! type -p download_srpm-$DISTRO; then
449                     fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
450                 else
451                     if ! download_srpm-$DISTRO "$target" "$srpm" "$force"; then
452                         fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTRO."
453                     fi
454                 fi
455             fi
456         else
457             fatal 1 "$srpm not found in directory $KERNELDIR."
458         fi
459     fi
460
461 }
462
463 download_file() {
464     local from="$1"
465     local to="$2"
466     local force="$3"
467
468     local file=${from##*/}
469
470     if [ -d $to ]; then
471         to="$to/$file"
472     fi
473
474     local semaphore="$to-downloading"
475
476     is_downloading() {
477         if [ ! -f $semaphore ]; then
478             return 1
479         fi
480
481         # make sure the download has not been aborted
482         local now=$(date +%s)
483         local file_mtime=$(stat -c %Y "$to")
484         local staleness=$((now - file_mtime))
485         # let's assume an active download will write at least once a minute
486         if [ $staleness -gt 60 ]; then
487             return 1
488         fi
489
490         return 0
491     }
492
493     is_downloaded() {
494         # if the semaphore file exists, the file is either still downloading
495         # or a download was aborted and we cannot trust the target file
496         if [ -f $semaphore ]; then
497             return 1
498         fi
499
500         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
501             return 0
502         fi
503
504         return 1
505     }
506
507     if $force || ! is_downloaded; then
508         if is_downloading; then
509             echo "Somebody else is downloading $from..."
510             while is_downloading; do
511                 echo "Waiting for $to to finish downloading"
512                 sleep 60
513             done
514             if is_downloaded; then
515                 return 0
516             else
517                 echo "The download we were waiting for seems to have been aborted"
518             fi
519
520         fi
521
522         if $DOWNLOAD; then
523             echo "Downloading $from..."
524             # flag others so they don't try to download also
525             push_exit_trap "rm -f $to $semaphore" "download"
526             touch $semaphore
527             if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
528                 # the trap will remove the files via the fatal below
529                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
530             fi
531             rm -f $semaphore
532             delete_exit_trap "download"
533         else
534             fatal 1 "${to##*/} not found in directory ${to%/*}."
535         fi
536     fi
537
538     return 0
539
540 }
541
542 download_ofed() {
543     local force="${1:-false}"
544
545     if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
546         return 0
547     fi
548
549     local OFED_BASE_VERSION=$OFED_VERSION
550     if [[ $OFED_VERSION = *.*.*.* ]]; then
551         OFED_BASE_VERSION=${OFED_VERSION%.*}
552     fi
553
554     local location="http://www.openfabrics.org/downloads/OFED/ofed-${OFED_BASE_VERSION}/"
555
556     if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
557         local Mmv
558         Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
559         location="http://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
560     fi
561
562     if [[ $OFED_VERSION = daily-* ]]; then
563         local Mmv daily
564         OFED_VERSION=${OFED_VERSION/daily-/}
565         Mmv=${OFED_VERSION%%-*}
566         daily=${OFED_VERSION##$Mmv-}
567         location="http://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
568         # find the filename for the version for the date specified
569         OFED_VERSION=$(curl -s "$location" | sed -nre "/${daily}-/s/.*href=\"OFED-(${Mmv//./\\.}-${daily}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
570         if [ -z "$OFED_VERSION" ]; then
571             fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
572         fi
573     fi
574
575     local file="OFED-${OFED_VERSION}.tgz"
576     download_file "$location/$file" "$KERNELTREE" "$force"
577
578 }
579
580 parse_mpss_info() {
581     local file="$1"
582     local build="$2"
583     local distro="$3"
584
585     [ -r "$file" ] || fatal 1 "Could not find MPSS info file"
586
587     # convert to MPSS distro naming
588     distro=${distro/sles/suse}
589     distro_name=${distro%%-*}
590
591     # extract links from MPSS info file
592     local urls=$(cat "$file" | \
593         tr -d '\t\r\n' | sed -e 's?\(</[a-zA-Z]*>\)?\1\n?g' | \
594         grep '.intel.com/' | \
595         sed -e 's/^.*[hH][rR][eE][fF]="\([^>"]\+\)".*$/\1/g' | \
596         grep '.tar')
597     local res2=""
598     local res3=""
599     for url in $urls; do
600         local ver2=""
601         local ver3=""
602         # Try to match with MPSS 3.x or 3.x.x distro package
603         if [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-$distro.tar ]]; then
604             ver3=${url##*mpss-}
605             ver3=${ver3%%-$distro.tar}
606         # Try to match with MPSS 3.x or 3.x.x source package
607         elif [[ $url =~ mpss-src-[0-9].[0-9](.[0-9]*)?.tar ]]; then
608             ver3=${url##*mpss-src-}
609             ver3=${ver3%%.tar}
610         # Try to match with MPSS 3.x or 3.x.x cross compiler package
611         elif [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-k1om.tar ]]; then
612             ver3=${url##*mpss-}
613             ver3=${ver3%%-k1om.tar}
614         # Try to match with MPSS 2.1.x source package
615         elif [[ $url =~ _src-[0-9].[0-9].[0-9]*-[0-9]*_$distro_name.tar ]]; then
616             ver2=${url##*_src-}
617             ver2=${ver2%%_$distro_name.tar}
618         fi
619
620         if [ -n "$ver3" ]; then
621             # Check for MPSS 3.x or MPSS 3.x.x
622             if [[ $ver3 =~ [0-9].[0-9].[0-9]* ]]; then
623                 ver3="${ver3}-0"
624             else
625                 ver3="${ver3}.0-0"
626             fi
627             if [ -z "$build" ]; then
628                 res3="$ver3"
629             elif [ "$build" = "$ver3" ]; then
630                 res3="$res3 $url"
631             fi
632         elif [ -n "$ver2" ]; then
633             if [ -z "$build" ]; then
634                 res2="$ver2"
635             elif [ "$build" = "$ver2" ]; then
636                 res2="$res2 $url"
637             fi
638         fi
639
640     done
641
642     if [ -z "$build" ]; then
643         # return a last version of MPSS
644         if [ -n "$res3" ]; then
645             echo "$res3"
646         else
647             echo "$res2"
648         fi
649     elif [ "${build%%.*}" = "3" ]; then
650         local ver=${build%%-*}
651         local bid=${build##*-}
652         if [ $bid -eq 0 ]; then
653             # return URLs from MPSS info file
654             echo "$res3"
655         else
656             # Check for MPSS 3.x or MPSS 3.x.x
657             if [ ${ver##*.} -eq 0 ]; then
658                 ver=${ver%.*}
659             fi
660             # return URLs from internal site with MPSS builds
661             # kernel sources:
662             echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-src-$ver.tar"
663             # kernel configs:
664             echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-$ver-k1om.tar"
665             # OFED headers:
666             echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-$ver-$distro.tar"
667         fi
668     else
669         # return URLs from MPSS info file
670         echo "$res2"
671     fi
672 }
673
674 # Get public information about last releases of
675 # Intel Manycore Platform Software Stack (MPSS)
676 download_mpss_info() {
677     local file="$1"
678     local force="${2:-true}"
679     local url=${MPSS_URL:-"http://software.intel.com/en-us/articles/intel-manycore-platform-software-stack-mpss"}
680
681     download_file "$url" "$file" "$force"
682 }
683
684 download_mpss() {
685     local file="$1"
686     local force="${2:-false}"
687     local urls=$(parse_mpss_info "$file" ${MPSS_VERSION} ${MPSS_DISTRO})
688
689     [ -z "$urls" ] && fatal 1 "Could not determine the URLs of MPSS $MPSS_VERSION"
690
691     # force re-download if build number is zero
692     [[ $MPSS_VERSION = [0-9].[0-9].[0-9]*-0 ]] && force=true
693
694     local url
695     local i=0
696     for url in $urls; do
697         file="$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part$i.tar"
698         download_file "$url" "$file" "$force"
699         i=$((i+1))
700     done
701 }
702
703 load_target() {
704
705     EXTRA_VERSION_save="$EXTRA_VERSION"
706     for patchesdir in "$EXTERNAL_PATCHES" \
707                       "$TOPDIR/lustre/lustre/kernel_patches"; do
708         TARGET_FILE="$patchesdir/targets/$TARGET.target"
709         [ -r "$TARGET_FILE" ] && break
710     done
711     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
712
713     echo "Loading target config file $TARGET.target..."
714
715     # if the caller specified an OFED_VERSION it should override whatever
716     # the target file specifies
717     local env_OFED_VERSION="$OFED_VERSION"
718
719     . "$TARGET_FILE"
720
721     if [ -n "$env_OFED_VERSION" ]; then
722         OFED_VERSION="$env_OFED_VERSION"
723     fi
724
725     # doesn't make any sense to build OFED for xen domX's
726     if $XEN; then
727         OFED_VERSION=""
728     fi
729
730     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
731     #       go away and the target just specify the $RPMSMPTYPE
732     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
733
734     # CC might have been overwriten in TARGET_FILE
735     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
736         export CCACHE && export CC="ccache $CC"
737     fi
738
739     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
740         KERNELDIR="$KERNELTREE/${lnxmaj}"
741         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
742     fi
743
744     # verify the series is available
745     if [ "$SERIES" ]; then
746         for series in $SERIES; do
747             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
748                 [ -r "$patchesdir/series/$series" ] && continue 2
749             done
750             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
751         done
752     fi
753
754     # set the location of the .config file
755     local XENPOSTFIX=""
756     if $XEN; then
757         XENPOSTFIX="-xen"
758     fi
759
760     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
761         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
762     fi
763
764     local lnxrelnew=${lnxrel//-/_}
765
766     # remember the EXTRA_VERSION before we diddle it here
767     # XXX - we really should not diddle with any values read in from the
768     #       target file.  if we want to modify a value, we should create
769     #       a new variable.
770     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
771
772     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
773         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
774     fi
775
776     if [ "$EXTRA_VERSION_save" ]; then
777         EXTRA_VERSION="$EXTRA_VERSION_save"
778     elif ! $RELEASE; then
779         # if there is no patch series, then this is not a lustre specific
780         # kernel.  don't make it look like one
781         if $PATCHLESS || [ -n "$SERIES" ]; then
782             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
783             if ! $PATCHLESS && [ -n "$BUILDID" ]; then
784                 EXTRA_VERSION="${EXTRA_VERSION}.${BUILDID}"
785             fi
786         fi
787     fi
788     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
789
790     ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
791
792     BUILD_ARCHS=
793     for arch in $(uniqify "$ALL_ARCHS"); do
794         if [ -z "$TARGET_ARCHS" ] ||
795            [[ \ $TARGET_ARCHS\  = *\ $arch\ * ]]; then
796             BUILD_ARCHS="$BUILD_ARCHS $arch"
797         fi
798     done
799     [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
800     echo "Building for: $BUILD_ARCHS"
801 }
802
803 tarflags() {
804     local file="$1"
805
806     case "$file" in
807         '')
808             fatal 1 "tarflags(): File name argument missing."
809             ;;
810         *.tar.gz | *.tgz)
811             echo 'zxf'
812             ;;
813         *.tar.bz2)
814             echo 'jxf'
815             ;;
816         *.tar)
817             echo 'xf'
818             ;;
819         *)
820             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
821             ;;
822     esac
823
824 }
825
826 untar() {
827     local tarfile="$1"
828     shift
829     local extractfile="$@"
830
831     echo "Untarring ${tarfile##*/}..."
832     tar $(tarflags "$tarfile") "$tarfile" $extractfile
833
834 }
835
836 unpack_ofed() {
837
838     if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
839         return 1
840     fi
841     [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
842
843 }
844
845 unpack_lustre() {
846
847     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
848     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
849
850 }
851
852 unpack_mpss() {
853
854     [ -d mpss ] && return 0
855
856     if [ "${MPSS_VERSION%%.*}" = "3" ]; then
857         local ver=${MPSS_VERSION%%-*}
858         local file
859         local i
860         # Check for MPSS 3.x or MPSS 3.x.x
861         if [ ${ver##*.} -eq 0 ]; then
862             ver=${ver%.*}
863         fi
864         for i in $(seq 0 9); do
865             file="$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part$i.tar"
866             if [ -r "$file" ]; then
867                 untar "$file" \
868                     "mpss-$ver/*/linux-*.tar.bz2" \
869                     "mpss-$ver/*/kernel-dev-*.rpm" \
870                     "mpss-$ver/*/ofed-driver-*-devel-*.rpm"
871             fi
872         done
873         # Extract kernel configs
874         file=$(find mpss-$ver -type f -path "*/kernel-dev-*.rpm")
875         if ! rpm2cpio "$file" | cpio -idm; then
876             echo "Error extracting MPSS kernel configs"
877             return 1
878         fi
879         # Unpack kernel sources
880         file=$(find mpss-$ver -type f -path "*/linux-*.tar.bz2")
881         if ! untar "$file"; then
882             echo "Error unpacking MPSS kernel sources"
883             return 1
884         fi
885         # Extract OFED headers
886         file=$(find mpss-$ver -type f -path "*/ofed-driver-*-devel-*.rpm")
887         if ! rpm2cpio "$file" | cpio -idm; then
888             echo "Error extracting MPSS OFED headers"
889             return 1
890         fi
891         # Remove unpacked archives to save space
892         rm -rf mpss-$ver
893         # Make link to MPSS kernel sources
894         ln -sf linux-* mpss
895     else
896         local dir="mpss-${MPSS_VERSION}-${MPSS_DISTRO%%-*}"
897
898         mkdir $dir || return 255
899         pushd $dir >/dev/null || return 255
900         if ! untar "$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part0.tar" "*/gpl/*full_src*"; then
901             popd >/dev/null
902             rm -rf $dir
903             echo "Error unpacking MPSS tarball 1"
904             return 1
905         fi
906         local file=$(find . -type f -path "*/gpl/*full_src*")
907         if ! untar "$file"; then
908             popd >/dev/null
909             rm -rf $dir
910             echo "Error unpacking MPSS tarball 2"
911             return 1
912         fi
913         popd >/dev/null
914         ln -sf $dir mpss
915     fi
916
917 }
918
919 do_patch_linux() {
920
921     local do_patch=${1:-true}
922
923     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
924     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
925     $do_patch && pushd linux >/dev/null
926     for series in $SERIES; do
927         echo -n "Applying series $series:"
928         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
929             [ -r "$patchesdir/series/$series" ] || continue
930             SERIES_FILE="$patchesdir/series/$series"
931             for patch in $(<"$SERIES_FILE"); do
932                 echo -n " $patch"
933                 PATCH_FILE="$patchesdir/patches/$patch"
934                 [ -r "$PATCH_FILE" ] || \
935                     fatal 1 "Patch $patch does not exist in Lustre tree."
936                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
937                     rm -f $FULL_PATCH
938                     fatal 1 "Error adding patch $patch to full patch."
939                 }
940                 if $do_patch; then
941                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
942                         rm -f $FULL_PATCH
943                         fatal 1 "Error applying patch $patch."
944                     }
945                 fi
946             done
947             break
948         done
949         echo
950     done
951     $do_patch && popd >/dev/null
952     echo "Full patch has been saved in ${FULL_PATCH##*/}."
953
954 }
955
956 build_lustre() {
957     local linux="$1"
958     local linuxobj="$2"
959
960     cp "$LUSTRE" SOURCES
961
962     pushd lustre >/dev/null
963
964     echo "Building Lustre RPMs for: $BUILD_ARCHS..."
965     local targets arch
966     for arch in $BUILD_ARCHS; do
967         targets="--target $arch $targets"
968     done
969
970     local confoptions=""
971
972     if $PATCHLESS; then
973         confoptions="$confoptions --disable-server"
974     fi
975
976     local rpmbuildopt='-tb'
977     if $NORPM; then
978         rpmbuildopt='-tc'
979         echo NORPM mode. Only compiling.
980     fi
981
982     # If server we now build the spl and zfs modules against the lustre kernel.
983     # These are required prior to the building of lustre server. Client does
984     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
985     # line above so is at least consistant.
986     if [ $PATCHLESS == false ] && [ "x$ZFSNOTSUPPORTED" == "x" ]; then
987         if ! build_spl_zfs; then
988             popd >/dev/null # pushd lustre
989             return 255
990         fi
991     fi
992
993     if $PATCHLESS; then
994         RPMBUILD_DEFS="$RPMBUILD_DEFS --without servers"
995         if [ -n "$CROSS_SUFFIX" ]; then
996             RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"lustre_name lustre-client$CROSS_SUFFIX\""
997         fi
998     fi
999
1000     # ditto for the lustre-tests boolean
1001     if ! $LUSTRE_TESTS; then
1002         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_tests"
1003     fi
1004
1005     if ! $IOKITRPM; then
1006         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_iokit"
1007     fi
1008
1009     local osd_zfs=""
1010     if $OSDZFSRPM; then
1011         osd_zfs="yes"
1012     fi
1013
1014     local osd_ldiskfs=""
1015     if $OSDLDISKFSRPM; then
1016         osd_ldiskfs="yes"
1017     fi
1018
1019     RPMBUILD_DEFS="$RPMBUILD_DEFS ${FIND_REQUIRES:+--define \"__find_requires $FIND_REQUIRES\"}"
1020     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"configure_args $confoptions ${CONFIGURE_FLAGS}\""
1021     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kdir $linux\""
1022     RPMBUILD_DEFS="$RPMBUILD_DEFS ${linuxobj:+--define \"kobjdir $linuxobj\"}"
1023     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_tmppath $TMPDIR\""
1024     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_topdir $TOPDIR\""
1025
1026     eval $RPMBUILD $targets $rpmbuildopt "$LUSTRE" $RPMBUILD_DEFS \
1027         ${osd_zfs:+--with zfs} \
1028         ${osd_ldiskfs:+--with ldiskfs} 2>&1 || \
1029         fatal 1 "Error building rpms for $BUILD_ARCHS."
1030
1031     if $DO_SRC; then
1032         if ! eval $RPMBUILD -ts "$LUSTRE" $RPMBUILD_DEFS 2>&1; then
1033             popd >/dev/null
1034             return 255
1035         fi
1036     fi
1037     popd >/dev/null
1038
1039 }
1040
1041 ###
1042 # build_spl_zfs
1043 #
1044 # Fetch spl/zfs from the git repo and prepare for lustre build
1045 #
1046 # Overrides:
1047 #   SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
1048 #   SPLZFSTAG     - Tag to checkout of clone repositories
1049 #   SPLZFSVER     - Version to checkout of both (format zfs/spl-$SPLZFSVER)
1050 #
1051 # return 0 if successful, else 255
1052 build_spl_zfs() {
1053     # make sure the RPM build environment is set up
1054     pushd $TOPDIR
1055     create_rpmbuild_dirs
1056     popd
1057
1058     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
1059     # destination for the rpms
1060     export RPM_BUILD_ROOT=$TOPDIR
1061     SPLZFSVER=${SPLZFSVER:-0.6.2}
1062     SPLZFSTAG=${SPLZFSTAG:-upstream-master}
1063
1064     # The files expect a kver to be set to the kernel version .
1065     local kver=$(find_linux_release)
1066
1067     # build and install the spl and zfs (and -devel) RPMs for lustre to use
1068     local pkg
1069     for pkg in spl zfs; do
1070
1071         local rpmpkg
1072
1073         [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*/|tail -1)"
1074
1075         # need to fetch the repo in order to build it.
1076         # default to github but allow override
1077         git clone ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
1078
1079         pushd $pkg || return 255
1080         if [ -n "$SPLZFSTAG" ]; then
1081             git checkout $SPLZFSTAG
1082         else
1083             git checkout -b lbuild $pkg-$SPLZFSVER
1084         fi
1085
1086         # This differentiates between older zfs versions
1087         if [ -f $pkg-modules.spec.in ]; then
1088             rpmpkg=$pkg-modules
1089             specdir=.
1090             speclist="$pkg.spec $rpmpkg.spec"
1091         else
1092             rpmpkg=kmod-$pkg-devel
1093             specdir=rpm/generic
1094             speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
1095         fi
1096
1097         sh autogen.sh || return 255
1098
1099         if  ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
1100                           ${spldir:+--with-spl="${spldir}"} 2>&1 ||
1101             ! make dist 2>&1; then
1102             popd
1103             return 255
1104         fi
1105         popd
1106
1107         ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
1108            error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
1109         if [ -f $pkg/scripts/kmodtool ]; then
1110             ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
1111         fi
1112
1113         local rpmb
1114         if $DO_SRC; then
1115             rpmb=-ba
1116         else
1117             rpmb=-bb
1118         fi
1119
1120         # set search dir for our own kmodtool to find correct
1121         # directories
1122         export KERNELSOURCE=$(dirname ${LINUX})
1123         # Manually build rpms
1124         for spec in $speclist; do
1125             echo "Building RPMs from $pkg/$specdir/$spec"
1126             if ! $RPMBUILD $rpmb $pkg/$specdir/$spec \
1127                 --nodeps -v \
1128                 --define "require_kdir ${LINUX}" \
1129                 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
1130                 ${spldir:+--define "require_spldir ${spldir}"} \
1131                 --define "kver $kver" \
1132                 --define "kernels $kver" \
1133                 --define "_tmppath /var/tmp" \
1134                 --define "kernelbuildroot $TOPDIR/reused" \
1135                 --define "_topdir $TOPDIR" 2>&1; then
1136                 return 255
1137             fi
1138         done
1139
1140 #       $DO_SRC && mv $pkg*.src.rpm $TOPDIR/SRPMS/
1141 #       mv $pkg*.noarch.rpm $TOPDIR/RPMS/noarch/
1142 #       mv *$pkg*.$TARGET_ARCH.rpm $TOPDIR/RPMS/$(basearch $TARGET_ARCH)/
1143
1144         # We have built the rpms for the package. Now we need to extract the
1145         # contained files so we can build further things against them
1146         local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
1147
1148         # cpio only extract to pwd so we need to go there.
1149         pushd $TOPDIR
1150         local rpm
1151         for rpm in $rpms; do
1152             rpm2cpio $rpm | cpio -id
1153         done
1154
1155         if [ "$pkg" == "zfs" ]; then
1156             mkdir -p $TOPDIR/zfsdevel
1157             pushd $TOPDIR/zfsdevel
1158             # We also need to extract zfs-devel rpm
1159             local devel_rpm=$(ls -1 $TOPDIR/RPMS/*/$pkg-devel-*.rpm)
1160             rpm2cpio $devel_rpm | cpio -id
1161             popd
1162             CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR/zfsdevel ${CONFIGURE_FLAGS}"
1163         fi
1164         popd
1165
1166         CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*/|tail -1) ${CONFIGURE_FLAGS}"
1167         CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1168     done
1169
1170     OSDZFSRPM=true
1171
1172     return 0
1173 }
1174
1175 prepare_mpss() {
1176
1177     pushd mpss >/dev/null || return 255
1178     if [ "${MPSS_VERSION%%.*}" = "3" ]; then
1179         cp -f ../boot/config-* .config
1180         if ! make ARCH=k1om silentoldconfig ; then
1181             popd >/dev/null
1182             return 1
1183         fi
1184         if ! make ARCH=k1om modules_prepare ; then
1185             popd >/dev/null
1186             return 1
1187         fi
1188         cp -f ../boot/Module.symvers-* Module.symvers
1189     else
1190         if ! make defconfig-miclinux; then
1191             popd >/dev/null
1192             return 1
1193         fi
1194         if ! make -C card/kernel ARCH=k1om modules_prepare ; then
1195             popd >/dev/null
1196             return 1
1197         fi
1198     fi
1199     popd >/dev/null
1200
1201 }
1202
1203 stage() {
1204
1205     [ "$STAGEDIR" ] || return 0
1206
1207     for arch in $BUILD_ARCHS; do
1208         rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
1209         echo "${0##*/}: Copying RPMs into ${rpmdir}"
1210         mkdir -p "${rpmdir}"
1211         cp -v RPMS/${arch}/*.rpm "${rpmdir}"
1212         if [ -d RPMS/noarch ]; then
1213             cp -v RPMS/noarch/*.rpm "${rpmdir}"
1214         fi
1215     done
1216
1217     cp -v "$LUSTRE" "$STAGEDIR"
1218
1219 }
1220
1221 set_rpm_smp_type() {
1222
1223     local infact_arch="${TARGET_ARCH}"
1224
1225     RPMSMPTYPE=""
1226     [ "$infact_arch" == "i586" ] && infact_arch="i686"
1227
1228     local smp_type
1229     for smp_type in $SMP_ARCHS; do
1230         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1231     done
1232
1233     for smp_type in $BIGSMP_ARCHS; do
1234         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1235     done
1236
1237     for smp_type in $PPC64_ARCHS; do
1238         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1239     done
1240
1241     for smp_type in $DEFAULT_ARCHS; do
1242         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1243     done
1244
1245 }
1246
1247 # This function takes a linux include tree and digs out the linux release
1248 # from it. It is never called directly, only called from the distro
1249 # specific function find_linux_release() in lbuild-{rhel,sles}.
1250 _find_linux_release() {
1251     local SRC="$1"
1252     local LINUXRELEASEHEADER=""
1253
1254     LINUXRELEASEHEADER=$SRC/include/linux/version.h
1255     if [ -s $SRC/include/generated/utsrelease.h ]; then
1256         LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1257     elif [ -s $SRC/include/linux/utsrelease.h ]; then
1258         LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1259     fi
1260
1261     if [ ! -s $LINUXRELEASEHEADER ]; then
1262         fatal 1 "could not find UTS_RELEASE"
1263     fi
1264
1265     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1266 }
1267
1268 # unpack kernel(/source/devel) RPM
1269 #
1270 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1271 # needs to completely refactored.  It completely ingores that $BUILD_ARCHS may
1272 # contain a list of arches for which rpmbuild commands (including the one for
1273 # lustre itself)
1274 unpack_linux_devel_rpm() {
1275     local kernelrpm="${1}"
1276
1277     [ -f "$kernelrpm" ] || return 255
1278     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1279
1280     pushd $TOPDIR/reused &>/dev/null || return 255
1281
1282     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1283         return 255
1284     fi
1285
1286     # call a distro specific hook, if available
1287     if type -p unpack_linux_devel_rpm-$DISTRO; then
1288         if ! unpack_linux_devel_rpm-$DISTRO "$kernelrpm"; then
1289             return 255
1290         fi
1291     fi
1292
1293     popd &>/dev/null
1294
1295     find_linux_devel_paths $TOPDIR/reused
1296
1297     return 0
1298
1299 }
1300
1301 build_kernel_ib() {
1302     local linux="$1"
1303     local kib_prefix="$2"
1304     local kib_rpm="$3"
1305
1306     # build kernel-ib{,-devel}/compat-rdma{,-devel}
1307     local K_SRC="K_SRC"
1308     # ofed 1.3 had a bug in the rpm spec
1309     if [ "$OFED_VERSION" = "1.3" ]; then
1310         K_SRC="KSRC"
1311     fi
1312
1313     local OFED_CORE="--with-core-mod --with-ipoib-mod --with-sdp-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
1314     local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod"
1315
1316     if compare_version $OFED_VERSION 3.0; then
1317         OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1318     else
1319         OFED_HARDWARE="$OFED_HARDWARE --with-cxgb4-mod"
1320     fi
1321
1322     # some I/B drivers are architecture dependent and kernel-ib's configure
1323     # does not figure it out for us ~sigh~
1324     case "$TARGET_ARCH" in
1325         ppc64)
1326             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1327             ;;
1328     esac
1329     # we're no longer shipping the OFED iSCSI target
1330     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1331     OFED_ISCSI="--with-srp-mod"
1332     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1333     ##kernels >= 2.6.30)
1334     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1335     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1336     #fi
1337
1338     # assume we are just rebuilding the SRPM
1339     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1340     local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1341
1342     # but switch to building from the SPEC if we need to apply patches
1343     if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1344         BUILD_TYPE="-bb"
1345         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1346         SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1347         local file ed_fragment1 ed_fragment2 n=1
1348         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1349             ed_fragment1="$ed_fragment1
1350 Patch$n: ${file%%*/}"
1351             ed_fragment2="$ed_fragment2
1352 %patch$n -p0"
1353             cp $file ${TOPDIR}/SOURCES
1354             let n=$n+1
1355         done
1356         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1357             # Only apply the ed-scripts that should be used for the canonical target
1358             # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1359             # convention
1360             # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1361             # To apply the same change to multiple canonical target simply specify
1362             # a list of colon separated canoncial target names in the file name.
1363             echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1364                                    -e ":${CANONICAL_TARGET}.ed$"
1365             if [ $? -eq 0 ] ; then
1366                 ed_fragment3="$ed_fragment3
1367 $(cat $file)"
1368                 let n=$n+1
1369             fi
1370         done
1371
1372         if [ $n -gt 1 ]; then
1373             ed $SOURCE <<EOF
1374 /^Source: /a
1375 $ed_fragment1
1376 .
1377 /^%setup /a
1378 $ed_fragment2
1379 .
1380 $ed_fragment3
1381 wq
1382 EOF
1383         fi
1384     fi
1385
1386     local linuxrelease=$(find_linux_release)
1387     if compare_version $OFED_VERSION 3.0; then
1388         local OFA_KERNEL_RELEASE=$(echo -n ${linuxrelease} | sed -e 's/-/_/g')
1389     fi
1390     if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1391                   ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1392                   --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1393                   --define "KVERSION ${linuxrelease}" \
1394                   --define "$K_SRC ${linux}" \
1395                   --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1396                   ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1397                   --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1398                   ${SOURCE} 2>&1; then
1399         fatal 1 "Error building ${kib_rpm}"
1400     fi
1401
1402 }
1403
1404 store_for_reuse() {
1405     local articles="$1"
1406     local module="$2"
1407     local location="$3"
1408     local signature="$4"
1409     local use_links="$5"
1410
1411     local linkflag=""
1412     if $use_links; then
1413         linkflag="l"
1414     fi
1415
1416     local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\)  * src .*/\1/p')
1417     if [ -z "$default_iface" ]; then
1418         fatal 1 "Failed to determine the default route interface"
1419     fi
1420     local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1421     if [ -z "$unique_id" ]; then
1422         fatal 1 "Failed to determine a unique id from interface $default_interface"
1423     fi
1424
1425     local finallocation="$location"/"$signature"/"$module"
1426     location="$location"/"$signature-${unique_id}"/"$module"
1427     mkdir -p "$location"
1428     # the cleanup script removes any directory that doesn't have a
1429     # .lastused, so let's try to prevent that as soon as we can
1430     # this solution still slightly racy with the cleanup script
1431     # but the race is a lot tighter now
1432     touch -t 197001010000 "$location/.lastused"
1433     ## use eval/echo here to make sure shell expansions are performed
1434     #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1435     local article
1436     for article in $(eval echo $articles); do
1437         if ! cp -a${linkflag} "$article" "$location"; then
1438             error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1439             # rename the cache location so that it's not cached
1440             # product, but is around for analysis
1441             mv "$location"{,-bad-$(date +%s)} ||
1442                 error "failed to clean up a failed cache attempt" \
1443                       "in \"$location\" -- manual cleanup will be" \
1444                       "necessary"
1445             return 1
1446         fi
1447     done
1448
1449     # flag the cache as complete (i.e. in case lbuild was previously
1450     # interrupted while caching)
1451     touch "$location/.lastused"
1452
1453     # put the temporary location into the final location
1454     # (last one wins)
1455     mkdir -p "${finallocation%/*}"
1456     mv "$location" "$finallocation"
1457     rmdir "${location%/*}"
1458     return 0
1459
1460 }
1461
1462 reuse() {
1463     local module="$1"
1464     local dest="$2"
1465     local use_links="${3:-false}"
1466     local signature="$4"
1467
1468     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1469         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1470             # the .lastused flag is populated at the end of the caching to
1471             # signal that the caching was completed.  if that flag is not
1472             # there, then the cache is invalid (and should be removed in fact)
1473             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1474                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1475             return 1
1476         fi
1477
1478         # so that we know how stale this entry is
1479         touch $REUSEBUILD/$signature/$module/.lastused
1480
1481         if $use_links; then
1482             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1483                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1484             fi
1485         else
1486             # copying is pretty heavy
1487             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1488             # do some creative symlinking instead
1489             local dir
1490             for dir in BUILD SRPMS SPECS; do
1491                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1492                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1493                 fi
1494             done
1495             # sources have to be copied by file because we need SOURCES to
1496             # be a dir we can write into
1497 # could overrun ls's arg list here
1498             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1499             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1500                 xargs ln -t $dest/SOURCES -s
1501
1502             # same for RPMS/* dirs
1503 # could overrun ls's arg list here
1504             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1505             local dir
1506             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1507                 mkdir -p $dest/RPMS/${dir##*/}
1508                 find $dir -type f |
1509                   xargs ln -t $dest/RPMS/${dir##*/} -s
1510             done
1511         fi
1512         return 0
1513     else
1514         return 1
1515     fi
1516 }
1517
1518 basearch() {
1519     local arch="$1"
1520
1521     if [[ $arch = i[3456]86 ]]; then
1522         echo "i386"
1523     else
1524         echo "$arch"
1525     fi
1526
1527 }
1528
1529 build_kernel_with_srpm() {
1530     local outfd=$1
1531
1532     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1533         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1534     fi
1535
1536     # need to generate the patch for this target
1537     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1538
1539     # get an md5sum of the kernel patch + config for reuse check
1540     # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1541     #     in BUILD_ARCHS
1542     local release_str
1543     if $RELEASE; then
1544         local release_str="RELEASE=$RELEASE\n"
1545     fi
1546
1547     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1548         local REUSE_SIGNATURE=$({ echo -en $release_str;
1549                                   echo $BUILD_GEN;
1550                                   cat $CONFIG_FILE $TARGET_FILE $FULL_PATCH;
1551                                   cat $LBUILD_DIR/lbuild $LBUILD_DIR/lbuild-${DISTRO}; } |
1552                                 md5sum | cut -d" " -f1)
1553         # see if we can link to the reuse pool
1554         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1555         #       "library"
1556         local CAN_LINK_FOR_REUSE=false
1557         touch $REUSEBUILD/$$
1558         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1559             CAN_LINK_FOR_REUSE=true
1560         fi
1561         rm $REUSEBUILD/$$
1562     fi
1563
1564     # the extra version string to use for the kernel (which might be a reused
1565     # kernel, remember)
1566     local kernel_extra_version=""
1567     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1568                                    "$REUSE_SIGNATURE"; then
1569         # nothing cached, build from scratch
1570         if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1571             echo "Downloading kernel SRPM" >&${outfd}
1572             download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1573         fi
1574
1575         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1576                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1577             # should we clean this up or leave it for analysis?
1578             #rm -rf $RPMTOPDIR
1579             fatal 1 "Error installing kernel SRPM."
1580         fi
1581
1582         # put the Lustre kernel patch into the RPM build tree
1583         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1584         prepare_and_build_srpm >&${outfd} ||
1585             fatal 1 "failed to prepare_and_build_srpm"
1586
1587         if [ -z "$REUSE_SIGNATURE" ]; then
1588             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1589         else
1590             # store the resulting kernel RPM build tree for future use
1591             echo "Storing the built kernel for future reuse" >&${outfd}
1592             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1593                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1594                                  "$CAN_LINK_FOR_REUSE"; then
1595                 error "Failed to store kernel RPMS for reuse"
1596                 echo "unknown" >&${outfd}
1597                 return 1
1598             fi
1599         fi
1600     fi  # build reuse
1601
1602     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1603     local KERNEL_RPM
1604     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1605         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1606     fi
1607     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1608
1609     # should now have the following RPMs
1610     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1611     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1612     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1613     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1614     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1615
1616     echo $kernel_extra_version
1617     return 0
1618
1619 }
1620
1621 # build OFED
1622 # globals used:
1623 #    TOPDIR
1624 #    REUSEBUILD, USE_BUILD_CACHE
1625 #    CONFIGURE_FLAGS
1626
1627 build_ofed() {
1628     local linux="$1"
1629     local ofed_version="$2"
1630     local kib_prefix
1631     local kib_rpm
1632
1633     # if an ofed version is given, then it means use OFED proper,
1634     # not any vendor specific "inkernel" version
1635     if [ -z "$ofed_version" ]; then
1636         return 0
1637     fi
1638
1639     if [ "$ofed_version" = "inkernel" ]; then
1640         # see if there is a distro specific override for this and use
1641         # that if it exists
1642         # XXX we need to better integrate a distro specific override with
1643         #     the rest of this function so that all of the reuse cache
1644         #     stuff is leveraged given that 80% of this function is reuse
1645         if type -p build_ofed-${DISTRO}; then
1646             local ofed_location
1647             ofed_location=$(build_ofed-${DISTRO} ${STDOUT})
1648             local rc=${PIPESTATUS[0]}
1649             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1650             return $rc
1651         else
1652             return 0
1653         fi
1654     elif compare_version $OFED_VERSION 3.0; then
1655         kib_prefix="ofa_kernel"
1656         kib_rpm="kernel-ib"
1657     else
1658         kib_prefix="compat-rdma"
1659         kib_rpm="compat-rdma"
1660     fi
1661
1662     # build kernel-ib/compat-rdma
1663     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1664         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1665                                   echo "$(find_linux_release;
1666                                   echo "$BUILD_GEN")";
1667                                   cat "${linux}/include/linux/autoconf.h";
1668                                   cat "$LBUILD_DIR/lbuild" ;
1669                                   cat "$LBUILD_DIR/lbuild-${DISTRO}"; } |
1670                                 md5sum | cut -d" " -f1)
1671         # see if we can link to the reuse pool
1672         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1673         #       "library"
1674         local CAN_LINK_FOR_REUSE=false
1675         touch $REUSEBUILD/$$
1676         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1677             CAN_LINK_FOR_REUSE=true
1678         fi
1679         rm $REUSEBUILD/$$
1680     fi
1681
1682     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1683                                    "$REUSE_SIGNATURE"; then
1684         if [ -n "$REUSE_SIGNATURE" ]; then
1685             # stash away the existing built articles for a moment
1686             mkdir bak
1687             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1688             function mv_back {
1689                 pushd bak
1690                 find . | cpio -pudlm ..
1691                 popd
1692                 rm -rf bak
1693             }
1694             create_rpmbuild_dirs
1695         fi
1696         # build it
1697         build_kernel_ib "${linux}" "${kib_prefix}" "${kib_rpm}"
1698
1699         if [ -z "$REUSE_SIGNATURE" ]; then
1700             echo "No reuse signature was caculated so not storing the built ofed"
1701         else
1702             # store the resulting RPM build tree for future use
1703             echo "Storing the built ofed for future reuse"
1704             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1705                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1706                                  "$CAN_LINK_FOR_REUSE"; then
1707                 error "Failed to store OFED RPMS for reuse"
1708                 mv_back
1709                 return 1
1710             fi
1711             # put the stuff we stashed away back
1712             mv_back
1713         fi
1714     fi
1715
1716     pushd "$TOPDIR" >/dev/null
1717     rm -rf ${kib_rpm}-devel
1718     mkdir ${kib_rpm}-devel
1719     cd ${kib_rpm}-devel
1720     # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1721     # might be present on the file
1722     #local linuxrelease=$(find_linux_release)
1723     #ofed_version=$(echo $ofed_version |
1724     #               sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1725     # FIXME
1726     # OFED version will have 'hyphen' for minor release. (e.g. 3.5-1, instead
1727     # of 3.5.1) compat-rdma and compat-rdma-devel could have same version
1728     # number, but currectly not. Once OFED fix this in the future release, we
1729     # can remove following filter.
1730     #ofed_version=$(echo $ofed_version |
1731     #               sed -re 's/-([0-9]*-[rR][cC][0-9]*)$//')
1732     #local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1733     # I dont' know why we have gone through the trouble to filter out the name
1734     # of the rpm there should only be one ${kib_rpm}-devel built
1735     local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1736     if ! rpm2cpio < $rpm | cpio -id; then
1737         fatal 1 "could not unpack the ${kib_rpm}-devel rpm."
1738     fi
1739     CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/${kib_prefix} ${CONFIGURE_FLAGS}"
1740     popd >/dev/null
1741
1742 }
1743
1744 build_with_srpm() {
1745
1746     if ! $PATCHLESS; then
1747         local kernel_extra_version
1748         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1749             fatal 1 "Failed to build the kernel from it's SRPM"
1750         fi
1751
1752         for arch in $BUILD_ARCHS; do
1753             local kernel_devel_rpm
1754             if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1755                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1756             fi
1757
1758             # install the -devel RPM in preparation for modules builds
1759             if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1760                            "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1761                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1762             fi
1763         done
1764     else
1765         # need to find and unpack the vendor's own kernel-devel for patchless
1766         # client build
1767         local kernelrpm
1768         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1769             fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in ${KERNELRPMSBASE}/${lnxmaj}/${DISTRO}"
1770         fi
1771         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1772             fatal 1 "Could not find the Linux tree in $kernelrpm"
1773         fi
1774     fi
1775
1776     # ~sigh~  have to make copies of and modify some of the rpm
1777     # infrastructure files so that find-requires can find our unpacked
1778     # kernel-devel artifacts
1779     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1780     FIND_REQUIRES="$(pwd)/find-requires"
1781     chmod 755 {symset-table,find-requires{,.ksyms}}
1782     local tmp="$(pwd)"
1783     tmp="${tmp//\//\\/}"
1784     ed find-requires <<EOF
1785 1a
1786 set -x
1787 .
1788 /|.*find-requires.ksyms/s/|/| bash -x/
1789 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1790 wq
1791 EOF
1792     ed find-requires.ksyms <<EOF
1793 1a
1794 set -x
1795 .
1796 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1797 wq
1798 EOF
1799     ed symset-table <<EOF
1800 1a
1801 set -x
1802 .
1803 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1804 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1805 wq
1806 EOF
1807
1808     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1809         fatal 1 "error building OFED"
1810
1811     # now build Lustre
1812     if build_lustre "$LINUX" "$LINUXOBJ"; then
1813         # the build worked.  resolve any symlinked files (i.e. from reuse)
1814         # in RPMS/$arch to real files so that that that huge mess of
1815         # complication known as LTS can copy them yet somewhere else.
1816         # is it any wonder this whole process is so damn so?  anyone ever
1817         # heard of hardlinks?  it's this cool new thing that allows you save
1818         # tons of time and space by creating... well you can go read about
1819         # them if you have not heard about them yet.
1820         # can i say how much the implemenation of all of this really impedes
1821         # RPM reuse?
1822         local dir
1823         for dir in RPMS/*; do
1824             pushd $dir
1825             for file in $(ls); do
1826                 if [ -h $file ]; then
1827                     cp $file foo
1828                     mv foo $file
1829                 fi
1830             done
1831             popd
1832         done
1833         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1834         # as that's where LTS expects to find them
1835         for dir in RPMS/*; do
1836             if [ $dir = RPMS/$TARGET_ARCH ]; then
1837                 continue
1838             fi
1839             pushd $dir
1840             local files=$(ls)
1841             if [ -n "$files" ]; then
1842                 cp -al $files ../$TARGET_ARCH
1843             fi
1844             popd
1845         done
1846     else
1847         return 1
1848     fi
1849
1850 }
1851
1852 create_rpmbuild_dirs() {
1853
1854     [ -d RPMS ] || mkdir RPMS
1855     for arch in $BUILD_ARCHS; do
1856         if [[ $arch = i?86 ]]; then
1857             # some stupidity in the sles11 kernel spec requires an RPMS/i386
1858             # even if the target arch is i686
1859             [ -d RPMS/i386 ] || mkdir RPMS/i386
1860         fi
1861         [ -d RPMS/$arch ] || mkdir RPMS/$arch
1862     done
1863     [ -d RPMS/noarch ] || mkdir RPMS/noarch
1864     [ -d BUILD ] || mkdir BUILD
1865     [ -d SOURCES ] || mkdir SOURCES
1866     [ -d SPECS ] || mkdir SPECS
1867     [ -d SRPMS ] || mkdir SRPMS
1868
1869 }
1870
1871 new_list() {
1872
1873     echo ""
1874
1875 }
1876
1877 add_list() {
1878     local list="$1"
1879     local item="$2"
1880
1881     echo "$list $item"
1882
1883 }
1884
1885 is_list_member() {
1886     local list="$1"
1887     local item="$2"
1888
1889     [[ $list\  == *\ $item\ * ]]
1890
1891 }
1892
1893 #########################################################################
1894 # Generate a backtrace through the call stack.
1895 #
1896 # Input: None
1897 # Output: None
1898 #########################################################################
1899 backtrace() {
1900     local strip=${1:-1}
1901
1902     local funcname="" sourcefile="" lineno="" n
1903
1904     echo "Call stack: (most recent first)"
1905     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1906         funcname=${FUNCNAME[$n - 1]}
1907         sourcefile=$(basename ${BASH_SOURCE[$n]})
1908         lineno=${BASH_LINENO[$n - 1]}
1909         if [ $n = 1 ]; then
1910             let lineno-=11
1911         fi
1912         # Display function arguments
1913         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1914             local args newarg j p=0
1915             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1916                 newarg=${BASH_ARGV[$j + $p - 1]}
1917                 args="${args:+${args} }'${newarg}'"
1918             done
1919             let p+=${BASH_ARGC[$n - 1]}
1920         fi
1921         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1922     done
1923
1924     echo
1925     echo "BEGIN BACKTRACE"
1926
1927     #echo ${BASH_LINENO[*]}
1928     #echo ${BASH_SOURCE[*]}
1929     #echo ${FUNCNAME[*]}
1930     local i=$((${#FUNCNAME[@]} - 1))
1931     while [ $i -ge 0 ]; do
1932         local lineno=${BASH_LINENO[$i]}
1933         if [ $i = 0 ]; then
1934             let lineno-=11
1935         fi
1936         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1937         # Can't figure out how to get function args from other frames...
1938         local FUNCTION="${FUNCNAME[$i]}()"
1939         echo "$SOURCELINE:$FUNCTION"
1940         i=$((i - 1))
1941     done
1942
1943     echo "END BACKTRACE"
1944
1945     echo $BACKTRACE
1946
1947 }
1948
1949 seen_list=$(new_list)
1950 trap 'set +x;
1951 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1952 Unfortunately the above line number in the message may or may not be correct,
1953 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1954 echo
1955 # have we seen this one
1956 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1957
1958 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1959   echo "seen this one already"
1960 else
1961   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1962 fi
1963 backtrace
1964 ) ; set $xtrace' ERR
1965 set -E
1966
1967 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1968
1969 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ldiskfs,ccache,reuse:,norpm,disable-datestamp,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,mpss-version:,publish,release,set-value:,src,stage:,tag:,target:,target-archs:,with-linux:,xen -- "$@")
1970
1971 if [ $? != 0 ]; then
1972     usage 1
1973 fi
1974
1975 eval set -- "$options"
1976
1977 while [ "$1" ]; do
1978     case "$1" in
1979         '')
1980             usage 1
1981             ;;
1982         --ccache)
1983             CCACHE='ccache'
1984             shift
1985             ;;
1986         -D)
1987             DATE=$2
1988             shift 2
1989             ;;
1990         --external-patches)
1991             EXTERNAL_PATCHES=$2
1992             shift 2
1993             ;;
1994         --extraversion)
1995             EXTRA_VERSION=$2
1996             shift 2
1997             ;;
1998         --help | -h)
1999             usage 0
2000             ;;
2001         --kerneldir)
2002             KERNELDIR=$2
2003             shift 2
2004             ;;
2005         --kerneltree)
2006             if ! KERNELTREE=$(canon_path "$2"); then
2007                 fatal 1 "Could not determine the canonical location of $2"
2008             fi
2009             shift 2
2010             ;;
2011         --linux | --with-linux)
2012             if ! LINUX=$(canon_path "$2"); then
2013                 fatal 1 "Could not determine the canonical location of $2"
2014             fi
2015             shift 2
2016             ;;
2017         --distro)
2018             DISTRO=$2
2019             shift 2
2020             ;;
2021         --reuserpm)
2022             REUSERPM=$2
2023             shift 2
2024             ;;
2025         --reusebuild)
2026             if ! REUSEBUILD=$(canon_path "$2"); then
2027                 fatal 1 "Could not determine the canonical location of $2"
2028             fi
2029             shift 2
2030             ;;
2031         --norpm)
2032             NORPM=true
2033             shift
2034             ;;
2035         --ldiskfs)
2036             echo "WARNING: \"--ldiskfs\" is deprecated" > 2
2037             shift
2038             ;;
2039         --noiokit)
2040             IOKITRPM=false
2041             shift
2042             ;;
2043         --patchless)
2044             PATCHLESS=true
2045             shift
2046             ;;
2047         --kernelrpm)
2048             if ! KERNELRPMSBASE=$(canon_path "$2"); then
2049                 fatal 1 "Could not determine the canonical location of $2"
2050             fi
2051             shift 2
2052             ;;
2053         --timestamp)
2054             TIMESTAMP=$2
2055             shift 2
2056             ;;
2057         --lustre)
2058             if ! LUSTRE=$(canon_filepath "$2"); then
2059                 fatal 1 "Could not determine the canonical location of $2"
2060             fi
2061             shift 2
2062             ;;
2063         --nodownload)
2064             DOWNLOAD=false
2065             shift 1
2066             ;;
2067         --nosrc)
2068             DO_SRC=false
2069             shift 1
2070             ;;
2071         --ofed-version)
2072             OFED_VERSION="$2"
2073             shift 2
2074             ;;
2075         --mpss-version)
2076             MPSS_VERSION="$2"
2077             shift 2
2078             ;;
2079         --publish)
2080             shift
2081             ;;
2082         --release)
2083             RELEASE=true
2084             shift
2085             ;;
2086         --src)
2087             DO_SRC=true
2088             shift 1
2089             ;;
2090         --stage)
2091             STAGEDIR=$2
2092             shift 2
2093             ;;
2094         --tag)
2095             shift 2
2096             echo "WARNING: \"--tag\" is deprecated" > 2
2097             ;;
2098         --target)
2099             TARGET=$2
2100             shift 2
2101             ;;
2102         --target-archs)
2103             TARGET_ARCHS=$2
2104             shift 2
2105             ;;
2106         --xen)
2107             XEN=true
2108             shift
2109             ;;
2110         --set-value)
2111             eval $2
2112             shift 2
2113             ;;
2114         --)
2115             shift
2116             # there are actually some lustre configure flags that we need to
2117             # handle ourselves (but we still give them to configure)
2118             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
2119                 LUSTRE_TESTS=false
2120             fi
2121             CONFIGURE_FLAGS=$@
2122             break
2123             ;;
2124         *)
2125             usage 1 "Unrecognized option: $1"
2126             ;;
2127     esac
2128 done
2129
2130 check_options
2131
2132 unpack_lustre
2133
2134 # XXX - should we _always_ get the buildid from the META file?  what are the
2135 # other (i.e. non-lustre-tarball use cases of lbuild)?
2136 BUILDID=$(sed -ne '/^BUILDID =/s/.*= *//p' lustre/META)
2137 VERSION=$(sed -ne '/^VERSION =/s/.*= *//p' lustre/META)
2138
2139 load_target
2140
2141 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
2142     download_ofed
2143     unpack_ofed || fatal 1 "Error unpacking OFED tarball"
2144 fi
2145
2146 if [ -n "$MPSS_VERSION" ]; then
2147     [ -z "$MPSS_DISTRO" ] && MPSS_DISTRO=$(autodetect_distro)
2148
2149     MPSS_INFO=$(mktemp -u mpss-info-XXXXXXXXXX.html)
2150     download_mpss_info "$MPSS_INFO"
2151
2152     if [ "$MPSS_VERSION" = "last" ]; then
2153         MPSS_VERSION=$(parse_mpss_info "$MPSS_INFO" "" ${MPSS_DISTRO})
2154         [ -z "$MPSS_VERSION" ] && fatal 1 "Could not determine the last MPSS version"
2155     elif [[ $MPSS_VERSION != [0-9].[0-9].[0-9]*-[0-9]* ]]; then
2156         fatal 1 "Incorrect MPSS version $MPSS_VERSION"
2157     fi
2158
2159     download_mpss "$MPSS_INFO"
2160     [ -r "$MPSS_INFO" ] && rm -f "$MPSS_INFO"
2161     echo "Building with MPSS $MPSS_VERSION"
2162     unpack_mpss  || fatal 1 "Error unpacking MPSS tarballs"
2163     prepare_mpss || fatal 1 "Error preparing MPSS for kernel modules build"
2164
2165     if [ -z "$MPSS_OFED" ]; then
2166         MPSS_OFED=$(find $PWD -type f -path "*/ofed-driver-*/Module.symvers")
2167         if [ -n "$MPSS_OFED" ]; then
2168             MPSS_OFED="--with-o2ib=$(dirname $MPSS_OFED)"
2169         else
2170             MPSS_OFED="--without-o2ib"
2171         fi
2172     fi
2173
2174     # disable unsupported parts:
2175     PATCHLESS=true
2176     IOKITRPM=false
2177     LDISKFSRPM=false
2178     ZFSNOTSUPPORTED="yes"
2179
2180     # define variables for cross compilation:
2181     CROSS_SUFFIX="-mic"
2182     if [ "${MPSS_VERSION%%.*}" = "3" ]; then
2183         CC_TARGET_ARCH=k1om-mpss-linux
2184         LINUX="$TOPDIR/mpss"
2185     else
2186         CC_TARGET_ARCH=x86_64-k1om-linux
2187         LINUX="$TOPDIR/mpss/card/kernel"
2188         RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires intel-mic-gpl = ${MPSS_VERSION%%-*}\""
2189     fi
2190     CONFIGURE_FLAGS="$CONFIGURE_FLAGS $MPSS_OFED --host=$CC_TARGET_ARCH --build=x86_64-pc-linux"
2191     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"post_script build/gen_filelist.sh\""
2192     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"make_args ARCH=k1om CROSS_COMPILE=${CC_TARGET_ARCH}-\""
2193     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_path ${CROSS_PATH:=/opt/lustre/${VERSION}/${CC_TARGET_ARCH}}\""
2194     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"rootdir %{cross_path}\""
2195     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_prefix %{cross_path}/usr\""
2196     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_mandir %{_prefix}/share/man\""
2197     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_sysconfdir %{cross_path}/etc\""
2198     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kmoddir extra\""
2199
2200     # redefine CC for proper ./configure during rpmbuild
2201     export CC=${CC_TARGET_ARCH}-gcc
2202 fi
2203
2204 # make sure the RPM build environment is set up
2205 create_rpmbuild_dirs
2206
2207 # if an unpacked kernel source tree was given on the command line
2208 # just build lustre with it (nothing distro kernel specific here)
2209 if [ -n "$LINUX" ]; then
2210     find_linux_release() {
2211         _find_linux_release $LINUX
2212     }
2213     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
2214         fatal 1 "error building OFED"
2215     build_lustre "$LINUX" "$LINUXOBJ"
2216 else
2217     if [ ! -f "${LBUILD_DIR}/lbuild-$DISTRO" ]; then
2218         fatal 1 "${LBUILD_DIR}/lbuild-$DISTRO not found"
2219     fi
2220     source ${LBUILD_DIR}/lbuild-$DISTRO
2221     build_with_srpm || fatal 1 "Failed to build_with_srpm"
2222 fi
2223
2224 stage